# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section     free
%define repo_dir    m2_repo/repository
%define oname       was6-maven-plugin
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           mojo-was6-maven-plugin
Version:        1.1.1
Release:        1%{?dist}
Epoch:          0
Summary:        IBM WebSphere Application Server 6.1 support
License:        MIT
Group:          Development/Java
URL:            http://mojo.codehaus.org/was6-maven-plugin/
Source0:    mojo-was6-maven-plugin-1.1.1.tgz
# svn export http://svn.codehaus.org/mojo/tags/was6-maven-plugin-1.1.1/ mojo-was6-maven-plugin-1.1.1 && tar czf mojo-was6-maven-plugin-1.1.1.tgz mojo-was6-maven-plugin-1.1.1
Source1:    %{name}-settings.xml
Source2:    %{name}-jpp-depmap.xml

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:    java-devel >= 0:1.6.0
BuildRequires:    mojo-parent
BuildRequires:    maven2 >= 0:2.0.8
BuildRequires:    maven2-plugin-changes
BuildRequires:    maven2-plugin-eclipse
BuildRequires:    maven2-plugin-plugin
BuildRequires:    maven-surefire-provider-junit3
BuildRequires:    mojo-maven2-plugin-cobertura
BuildRequires:    mojo-maven2-plugin-findbugs
BuildRequires:    mojo-maven2-plugin-jdepend
BuildRequires:    apache-commons-io
BuildRequires:    apache-commons-lang
BuildRequires:    dom4j
BuildRequires:    jaxen
BuildRequires:    plexus-resources
BuildRequires:    plexus-utils
BuildRequires:    velocity
BuildRequires:    junit
Requires:    mojo-parent
Requires:    maven2 >= 0:2.0.8
Requires:    apache-commons-io
Requires:    apache-commons-lang
Requires:    dom4j
Requires:    jaxen
Requires:    plexus-resources
Requires:    plexus-utils

Requires:       jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0

%description
This plugin can be used to
* Generate EJB stub code
* Generate or modify resource descriptor
* Deploy EARs to targets (servers and/or clusters)
* Start/stop applications
* Start/stop targets (servers and/or clusters).
* Execute arbitrary scripts controlling WAS environments.
* Generate EAR files suitable for deploying into a WebSphere
  Process Server environment using ServiceDeploy.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q 
cp %{SOURCE1} maven2-settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export MAVEN_REPO_LOCAL=`pwd`/%{repo_dir}
export SETTINGS=$(pwd)/maven2-settings.xml

mvn-jpp -e \
    -s ${SETTINGS} \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    -Dmaven2.jpp.depmap.file=%{SOURCE2} \
    install javadoc:javadoc

#   -Dmaven.test.failure.ignore=true \


%install
rm -rf $RPM_BUILD_ROOT

# jars and poms
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-mojo-was6-maven-plugin.pom
%add_to_maven_depmap org.codehaus.mojo was6-maven-plugin %{version} JPP mojo-was6-maven-plugin
  
install -m 644 target/%{oname}-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-${version}.jar
ln -sf %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/*

%changelog
* Sun Jun 24 2012 Ralph Apel <r.apel@r-apel.de> 0:1.1.1-1
- First release

